# dkh - Needs to be updated since I've been having problems uploading the web to the XPP. Panel project
# requires flattening of web folder contents for more reliable uploads.
# See "Panel Client - Create web archive deploy from dev.txt" for required modifications prior to packaging...would be nice to automate all necessary changes.

################################################################################
# File Name: createWebUpdateArchive.ps1
#
# Simple Powershell script to create the Web Update archive that is uploaded
# using the Dev-Tool to update the Web Panel Software running on a QLCP.
################################################################################
$srcDir = "C:\Users\DamonH\Documents\SW_Repositories\GitHub\qlcp-panel-client"
# $dstDir = $PSScriptRoot
# $dstDir = $srcDir
$dstDir = $PWD


# Extract the version number from the qlcp-panel.js file.
$vsn = [regex]::match((Select-String -Path $srcDir\scripts\qlcp-panel.js -Pattern "SW_VERSION" -List).Line, '(?<=")(["0-9-a."]+)(?=")').Value
$dstPath = "$dstDir\QLCP_web_gui_$vsn.zip"

# Create a web folder if one does not exist.
# Delete the current contents of the web folder if it was already present
if (Test-Path -Path $srcDir/web) {
    Remove-Item -Path $srcDir/web/* -Recurse
} else {
    New-Item -Path $srcDir\web -ItemType Directory
}

# Make a temporary copy of the files in a new folder to establish the desired folder structure in the archive.
Copy-Item -Path $srcDir\index.jsp, $srcDir\*.html, $srcDir\assets, $srcDir\images, `
$srcDir\scripts, $srcDir\styles -Destination $srcDir\web -Recurse -Force

# Remove the existing archive if one with the same name already exists.
if (Test-Path $dstPath) {
Remove-Item -Path $dstPath
}

# Create a zip-archive with the specified contents from the qlcp-panel-client folder, named with the version number extracted above.
Compress-Archive -LiteralPath $srcDir\web -DestinationPath $dstPath -Force

# Delete the temporary web folder and it's contents now that the zip archive is created.
Remove-Item -Path $srcDir/web -Recurse